<?php
// auto-generated by sfPropelCrud
// date: 2008/10/21 01:27:12
?>
<?php

/**
 * session actions.
 *
 * @package    gesport
 * @subpackage session
 * @author     Diego Cebrián Martínez
 * @version    SVN: $Id: actions.class.php 3335 2007-01-23 16:19:56Z fabien $
 */
class sessionActions extends sfActions
{
  public function executeIndex()
  {
    return $this->forward('session', 'list');
  }

  public function executeList()
  {
    $this->sessions = SessionPeer::doSelect(new Criteria());
  }

  public function executeOneWeek()
  {
    $this->sessions = SessionPeer::doSelect(new Criteria());
  }

  public function executeOneDay()
  {
  	$c = new Criteria();
    $this->sessions = SessionPeer::doSelect($c);
  }


  public function executeOneMonth ()
  {
    $this->sessions = SessionPeer::doSelect(new Criteria());
  }
  public function executeShow()
  {
    $this->session = SessionPeer::retrieveByPk($this->getRequestParameter('id'));
    $this->forward404Unless($this->session);
  }

  public function executeCreate()
  {
    $this->session = new Session();

    $this->setTemplate('edit');
  }

  public function executeEdit()
  {
    $this->session = SessionPeer::retrieveByPk($this->getRequestParameter('id'));
    $this->forward404Unless($this->session);
  }

  public function executeUpdate()
  {
    if (!$this->getRequestParameter('id'))
    {
      $session = new Session();
    }
    else
    {
      $session = SessionPeer::retrieveByPk($this->getRequestParameter('id'));
      $this->forward404Unless($session);
    }

    $session->setId($this->getRequestParameter('id'));
    if ($this->getRequestParameter('date'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('date'), $this->getUser()->getCulture());
      $session->setDate("$y-$m-$d");
    }
    $session->setFeedback($this->getRequestParameter('feedback'));
    $session->setMicrocycleId($this->getRequestParameter('microcycle_id') ? $this->getRequestParameter('microcycle_id') : null);
    $session->setTheoricIntensity($this->getRequestParameter('theoric_intensity'));
    $session->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    $session->setReportedIntensity($this->getRequestParameter('reported_intensity'));
    $session->setReportedVolume($this->getRequestParameter('reported_volume'));

    $session->save();

    return $this->redirect('session/show?id='.$session->getId());
  }

  public function executeDelete()
  {
    $session = SessionPeer::retrieveByPk($this->getRequestParameter('id'));

    $this->forward404Unless($session);

    $session->delete();

    return $this->redirect('session/list');
  }  
  
  public function executeAdd()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
    	/*
    	 * search for the athlete that has the id of the parameter and his/her coach
    	 * is the user that is logged in. If anything fail (The athlete has another coach)
    	 * it will show error
    	 */
    	$c = new Criteria();
    	$c->add(UserPeer::ID, $this->getRequestParameter('id'));
    	$c->add(UserPeer::COACH_ID, $this->getUser()->getAttribute('user_id',0 , 'athlete'));
      $this->user = UserPeer::doSelect($c);
      $this->forward404Unless($this->user);
      // display the form
      $this->form_action="session_add";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and create the user
    else
    {
      // handle the form submission
      $this->user = new User();
      $this->coach = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
      $this->forward404Unless($this->user);  
      $this->forward404Unless($this->coach); 
      $user=$this->update($this->user);
      
      //generate the password for the new user
      $password = $user->generatePassword();

      //Send the email to the user with the password
      $this->getRequest()->setAttribute('password', $password);
      $this->getRequest()->setAttribute('nickname', $user->getNickname());
      $this->getRequest()->setAttribute('name', $user->__toString());
     
      $raw_email = $this->sendEmail('mail', 'createUser');
      //debur function (noly in dev mode)
      $this->logMessage($raw_email, 'debug');
        
      $user->save();
      
      // redirect to the page of the new user
      return $this->redirect('@athlete_show?id='.$user->getId());
    }
  }
  
  public function handleErrorAdd()
  {
    $this->user = new User();
    $this->user = $this->update($this->user);
    $this->coach = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
    $this->forward404Unless($this->coach); 
    $this->forward404Unless($this->user);
    return sfView::SUCCESS;
  }
}
