<?php

/**
 * Subclass for performing query and update operations on the 'mesocycle' table.
 *
 * 
 *
 * @package lib.model
 */ 
class MesocyclePeer extends BaseMesocyclePeer
{

  public static function retrieveCurrentByUserId($user_id) {
    $c=new Criteria();
    $c->addJoin(MesocyclePeer::MACROCYCLE_ID, MacrocyclePeer::ID);
    $c->addJoin(MacrocyclePeer::SEASON_ID, SeasonPeer::ID);
    $c->add(SeasonPeer::USER_ID, $user_id);
    $c->add(MesocyclePeer::START_AT, date('Y-m-d'), Criteria::LESS_EQUAL);
    $c->add(MesocyclePeer::LAST_DAY_AT, date("Y-m-d"), Criteria::GREATER_EQUAL);
    return MesocyclePeer::doSelectOne($c);
  }
  
  public static function retrieveByUserIdAndPk($user_id,$pk) {
    $c=new Criteria();
    $c->addJoin(MesocyclePeer::MACROCYCLE_ID, MacrocyclePeer::ID);
    $c->addJoin(MacrocyclePeer::SEASON_ID, SeasonPeer::ID);
    $c->add(SeasonPeer::USER_ID, $user_id);
    $c->add(MesocyclePeer::ID, $pk);
    return MesocyclePeer::doSelectOne($c);
  } 
}
