<?php



class SessionElementMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.SessionElementMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('session_element');
		$tMap->setPhpName('SessionElement');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('DESCRIPTION', 'Description', 'string', CreoleTypes::VARCHAR, false, 250);

		$tMap->addColumn('LEVEL', 'Level', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addForeignKey('WORKING_METHOD_ID', 'WorkingMethodId', 'int', CreoleTypes::INTEGER, 'working_method', 'ID', false, null);

		$tMap->addForeignKey('SESSION_ID', 'SessionId', 'int', CreoleTypes::INTEGER, 'session', 'ID', false, null);

		$tMap->addColumn('THEORIC_INTENSITY', 'TheoricIntensity', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('THEORIC_VOLUME', 'TheoricVolume', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_INTENSITY', 'ReportedIntensity', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_VOLUME', 'ReportedVolume', 'double', CreoleTypes::DOUBLE, false, null);

	} 
} 