<?php


abstract class BaseCategory extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;


	
	protected $start_at;


	
	protected $end_at;


	
	protected $male;


	
	protected $event_id;


	
	protected $circuit_id;


	
	protected $price_id;


	
	protected $no_competitive;

	
	protected $aEvent;

	
	protected $aCircuit;

	
	protected $aPrice;

	
	protected $collRunners;

	
	protected $lastRunnerCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getStartAt()
	{

		return $this->start_at;
	}

	
	public function getEndAt()
	{

		return $this->end_at;
	}

	
	public function getMale()
	{

		return $this->male;
	}

	
	public function getEventId()
	{

		return $this->event_id;
	}

	
	public function getCircuitId()
	{

		return $this->circuit_id;
	}

	
	public function getPriceId()
	{

		return $this->price_id;
	}

	
	public function getNoCompetitive()
	{

		return $this->no_competitive;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = CategoryPeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = CategoryPeer::DESCRIPTION;
		}

	} 
	
	public function setStartAt($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->start_at !== $v) {
			$this->start_at = $v;
			$this->modifiedColumns[] = CategoryPeer::START_AT;
		}

	} 
	
	public function setEndAt($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->end_at !== $v) {
			$this->end_at = $v;
			$this->modifiedColumns[] = CategoryPeer::END_AT;
		}

	} 
	
	public function setMale($v)
	{

		if ($this->male !== $v) {
			$this->male = $v;
			$this->modifiedColumns[] = CategoryPeer::MALE;
		}

	} 
	
	public function setEventId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->event_id !== $v) {
			$this->event_id = $v;
			$this->modifiedColumns[] = CategoryPeer::EVENT_ID;
		}

		if ($this->aEvent !== null && $this->aEvent->getId() !== $v) {
			$this->aEvent = null;
		}

	} 
	
	public function setCircuitId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->circuit_id !== $v) {
			$this->circuit_id = $v;
			$this->modifiedColumns[] = CategoryPeer::CIRCUIT_ID;
		}

		if ($this->aCircuit !== null && $this->aCircuit->getId() !== $v) {
			$this->aCircuit = null;
		}

	} 
	
	public function setPriceId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->price_id !== $v) {
			$this->price_id = $v;
			$this->modifiedColumns[] = CategoryPeer::PRICE_ID;
		}

		if ($this->aPrice !== null && $this->aPrice->getId() !== $v) {
			$this->aPrice = null;
		}

	} 
	
	public function setNoCompetitive($v)
	{

		if ($this->no_competitive !== $v) {
			$this->no_competitive = $v;
			$this->modifiedColumns[] = CategoryPeer::NO_COMPETITIVE;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->start_at = $rs->getString($startcol + 2);

			$this->end_at = $rs->getString($startcol + 3);

			$this->male = $rs->getBoolean($startcol + 4);

			$this->event_id = $rs->getInt($startcol + 5);

			$this->circuit_id = $rs->getInt($startcol + 6);

			$this->price_id = $rs->getInt($startcol + 7);

			$this->no_competitive = $rs->getBoolean($startcol + 8);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 9; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Category object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CategoryPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			CategoryPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CategoryPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aEvent !== null) {
				if ($this->aEvent->isModified()) {
					$affectedRows += $this->aEvent->save($con);
				}
				$this->setEvent($this->aEvent);
			}

			if ($this->aCircuit !== null) {
				if ($this->aCircuit->isModified()) {
					$affectedRows += $this->aCircuit->save($con);
				}
				$this->setCircuit($this->aCircuit);
			}

			if ($this->aPrice !== null) {
				if ($this->aPrice->isModified()) {
					$affectedRows += $this->aPrice->save($con);
				}
				$this->setPrice($this->aPrice);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CategoryPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += CategoryPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collRunners !== null) {
				foreach($this->collRunners as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aEvent !== null) {
				if (!$this->aEvent->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aEvent->getValidationFailures());
				}
			}

			if ($this->aCircuit !== null) {
				if (!$this->aCircuit->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aCircuit->getValidationFailures());
				}
			}

			if ($this->aPrice !== null) {
				if (!$this->aPrice->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aPrice->getValidationFailures());
				}
			}


			if (($retval = CategoryPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collRunners !== null) {
					foreach($this->collRunners as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CategoryPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			case 2:
				return $this->getStartAt();
				break;
			case 3:
				return $this->getEndAt();
				break;
			case 4:
				return $this->getMale();
				break;
			case 5:
				return $this->getEventId();
				break;
			case 6:
				return $this->getCircuitId();
				break;
			case 7:
				return $this->getPriceId();
				break;
			case 8:
				return $this->getNoCompetitive();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CategoryPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
			$keys[2] => $this->getStartAt(),
			$keys[3] => $this->getEndAt(),
			$keys[4] => $this->getMale(),
			$keys[5] => $this->getEventId(),
			$keys[6] => $this->getCircuitId(),
			$keys[7] => $this->getPriceId(),
			$keys[8] => $this->getNoCompetitive(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CategoryPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
			case 2:
				$this->setStartAt($value);
				break;
			case 3:
				$this->setEndAt($value);
				break;
			case 4:
				$this->setMale($value);
				break;
			case 5:
				$this->setEventId($value);
				break;
			case 6:
				$this->setCircuitId($value);
				break;
			case 7:
				$this->setPriceId($value);
				break;
			case 8:
				$this->setNoCompetitive($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CategoryPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setStartAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setEndAt($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setMale($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setEventId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setCircuitId($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setPriceId($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setNoCompetitive($arr[$keys[8]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CategoryPeer::DATABASE_NAME);

		if ($this->isColumnModified(CategoryPeer::ID)) $criteria->add(CategoryPeer::ID, $this->id);
		if ($this->isColumnModified(CategoryPeer::DESCRIPTION)) $criteria->add(CategoryPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(CategoryPeer::START_AT)) $criteria->add(CategoryPeer::START_AT, $this->start_at);
		if ($this->isColumnModified(CategoryPeer::END_AT)) $criteria->add(CategoryPeer::END_AT, $this->end_at);
		if ($this->isColumnModified(CategoryPeer::MALE)) $criteria->add(CategoryPeer::MALE, $this->male);
		if ($this->isColumnModified(CategoryPeer::EVENT_ID)) $criteria->add(CategoryPeer::EVENT_ID, $this->event_id);
		if ($this->isColumnModified(CategoryPeer::CIRCUIT_ID)) $criteria->add(CategoryPeer::CIRCUIT_ID, $this->circuit_id);
		if ($this->isColumnModified(CategoryPeer::PRICE_ID)) $criteria->add(CategoryPeer::PRICE_ID, $this->price_id);
		if ($this->isColumnModified(CategoryPeer::NO_COMPETITIVE)) $criteria->add(CategoryPeer::NO_COMPETITIVE, $this->no_competitive);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CategoryPeer::DATABASE_NAME);

		$criteria->add(CategoryPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);

		$copyObj->setStartAt($this->start_at);

		$copyObj->setEndAt($this->end_at);

		$copyObj->setMale($this->male);

		$copyObj->setEventId($this->event_id);

		$copyObj->setCircuitId($this->circuit_id);

		$copyObj->setPriceId($this->price_id);

		$copyObj->setNoCompetitive($this->no_competitive);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getRunners() as $relObj) {
				$copyObj->addRunner($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CategoryPeer();
		}
		return self::$peer;
	}

	
	public function setEvent($v)
	{


		if ($v === null) {
			$this->setEventId(NULL);
		} else {
			$this->setEventId($v->getId());
		}


		$this->aEvent = $v;
	}


	
	public function getEvent($con = null)
	{
		if ($this->aEvent === null && ($this->event_id !== null)) {
						include_once 'lib/model/om/BaseEventPeer.php';

			$this->aEvent = EventPeer::retrieveByPK($this->event_id, $con);

			
		}
		return $this->aEvent;
	}

	
	public function setCircuit($v)
	{


		if ($v === null) {
			$this->setCircuitId(NULL);
		} else {
			$this->setCircuitId($v->getId());
		}


		$this->aCircuit = $v;
	}


	
	public function getCircuit($con = null)
	{
		if ($this->aCircuit === null && ($this->circuit_id !== null)) {
						include_once 'lib/model/om/BaseCircuitPeer.php';

			$this->aCircuit = CircuitPeer::retrieveByPK($this->circuit_id, $con);

			
		}
		return $this->aCircuit;
	}

	
	public function setPrice($v)
	{


		if ($v === null) {
			$this->setPriceId(NULL);
		} else {
			$this->setPriceId($v->getId());
		}


		$this->aPrice = $v;
	}


	
	public function getPrice($con = null)
	{
		if ($this->aPrice === null && ($this->price_id !== null)) {
						include_once 'lib/model/om/BasePricePeer.php';

			$this->aPrice = PricePeer::retrieveByPK($this->price_id, $con);

			
		}
		return $this->aPrice;
	}

	
	public function initRunners()
	{
		if ($this->collRunners === null) {
			$this->collRunners = array();
		}
	}

	
	public function getRunners($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRunners === null) {
			if ($this->isNew()) {
			   $this->collRunners = array();
			} else {

				$criteria->add(RunnerPeer::CATEGORY_ID, $this->getId());

				RunnerPeer::addSelectColumns($criteria);
				$this->collRunners = RunnerPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(RunnerPeer::CATEGORY_ID, $this->getId());

				RunnerPeer::addSelectColumns($criteria);
				if (!isset($this->lastRunnerCriteria) || !$this->lastRunnerCriteria->equals($criteria)) {
					$this->collRunners = RunnerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastRunnerCriteria = $criteria;
		return $this->collRunners;
	}

	
	public function countRunners($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(RunnerPeer::CATEGORY_ID, $this->getId());

		return RunnerPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addRunner(Runner $l)
	{
		$this->collRunners[] = $l;
		$l->setCategory($this);
	}


	
	public function getRunnersJoinSize($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRunners === null) {
			if ($this->isNew()) {
				$this->collRunners = array();
			} else {

				$criteria->add(RunnerPeer::CATEGORY_ID, $this->getId());

				$this->collRunners = RunnerPeer::doSelectJoinSize($criteria, $con);
			}
		} else {
									
			$criteria->add(RunnerPeer::CATEGORY_ID, $this->getId());

			if (!isset($this->lastRunnerCriteria) || !$this->lastRunnerCriteria->equals($criteria)) {
				$this->collRunners = RunnerPeer::doSelectJoinSize($criteria, $con);
			}
		}
		$this->lastRunnerCriteria = $criteria;

		return $this->collRunners;
	}


	
	public function getRunnersJoinInscription($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRunners === null) {
			if ($this->isNew()) {
				$this->collRunners = array();
			} else {

				$criteria->add(RunnerPeer::CATEGORY_ID, $this->getId());

				$this->collRunners = RunnerPeer::doSelectJoinInscription($criteria, $con);
			}
		} else {
									
			$criteria->add(RunnerPeer::CATEGORY_ID, $this->getId());

			if (!isset($this->lastRunnerCriteria) || !$this->lastRunnerCriteria->equals($criteria)) {
				$this->collRunners = RunnerPeer::doSelectJoinInscription($criteria, $con);
			}
		}
		$this->lastRunnerCriteria = $criteria;

		return $this->collRunners;
	}

} 