<?php


abstract class BaseCircuit extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;


	
	protected $distance;


	
	protected $event_id;


	
	protected $first_number;


	
	protected $last_number;

	
	protected $aEvent;

	
	protected $collCategorys;

	
	protected $lastCategoryCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getDistance()
	{

		return $this->distance;
	}

	
	public function getEventId()
	{

		return $this->event_id;
	}

	
	public function getFirstNumber()
	{

		return $this->first_number;
	}

	
	public function getLastNumber()
	{

		return $this->last_number;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = CircuitPeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = CircuitPeer::DESCRIPTION;
		}

	} 
	
	public function setDistance($v)
	{

		if ($this->distance !== $v) {
			$this->distance = $v;
			$this->modifiedColumns[] = CircuitPeer::DISTANCE;
		}

	} 
	
	public function setEventId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->event_id !== $v) {
			$this->event_id = $v;
			$this->modifiedColumns[] = CircuitPeer::EVENT_ID;
		}

		if ($this->aEvent !== null && $this->aEvent->getId() !== $v) {
			$this->aEvent = null;
		}

	} 
	
	public function setFirstNumber($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->first_number !== $v) {
			$this->first_number = $v;
			$this->modifiedColumns[] = CircuitPeer::FIRST_NUMBER;
		}

	} 
	
	public function setLastNumber($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->last_number !== $v) {
			$this->last_number = $v;
			$this->modifiedColumns[] = CircuitPeer::LAST_NUMBER;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->distance = $rs->getFloat($startcol + 2);

			$this->event_id = $rs->getInt($startcol + 3);

			$this->first_number = $rs->getInt($startcol + 4);

			$this->last_number = $rs->getInt($startcol + 5);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 6; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Circuit object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CircuitPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			CircuitPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CircuitPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aEvent !== null) {
				if ($this->aEvent->isModified()) {
					$affectedRows += $this->aEvent->save($con);
				}
				$this->setEvent($this->aEvent);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CircuitPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += CircuitPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collCategorys !== null) {
				foreach($this->collCategorys as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aEvent !== null) {
				if (!$this->aEvent->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aEvent->getValidationFailures());
				}
			}


			if (($retval = CircuitPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collCategorys !== null) {
					foreach($this->collCategorys as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CircuitPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			case 2:
				return $this->getDistance();
				break;
			case 3:
				return $this->getEventId();
				break;
			case 4:
				return $this->getFirstNumber();
				break;
			case 5:
				return $this->getLastNumber();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CircuitPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
			$keys[2] => $this->getDistance(),
			$keys[3] => $this->getEventId(),
			$keys[4] => $this->getFirstNumber(),
			$keys[5] => $this->getLastNumber(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CircuitPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
			case 2:
				$this->setDistance($value);
				break;
			case 3:
				$this->setEventId($value);
				break;
			case 4:
				$this->setFirstNumber($value);
				break;
			case 5:
				$this->setLastNumber($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CircuitPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setDistance($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setEventId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setFirstNumber($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setLastNumber($arr[$keys[5]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CircuitPeer::DATABASE_NAME);

		if ($this->isColumnModified(CircuitPeer::ID)) $criteria->add(CircuitPeer::ID, $this->id);
		if ($this->isColumnModified(CircuitPeer::DESCRIPTION)) $criteria->add(CircuitPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(CircuitPeer::DISTANCE)) $criteria->add(CircuitPeer::DISTANCE, $this->distance);
		if ($this->isColumnModified(CircuitPeer::EVENT_ID)) $criteria->add(CircuitPeer::EVENT_ID, $this->event_id);
		if ($this->isColumnModified(CircuitPeer::FIRST_NUMBER)) $criteria->add(CircuitPeer::FIRST_NUMBER, $this->first_number);
		if ($this->isColumnModified(CircuitPeer::LAST_NUMBER)) $criteria->add(CircuitPeer::LAST_NUMBER, $this->last_number);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CircuitPeer::DATABASE_NAME);

		$criteria->add(CircuitPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);

		$copyObj->setDistance($this->distance);

		$copyObj->setEventId($this->event_id);

		$copyObj->setFirstNumber($this->first_number);

		$copyObj->setLastNumber($this->last_number);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getCategorys() as $relObj) {
				$copyObj->addCategory($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CircuitPeer();
		}
		return self::$peer;
	}

	
	public function setEvent($v)
	{


		if ($v === null) {
			$this->setEventId(NULL);
		} else {
			$this->setEventId($v->getId());
		}


		$this->aEvent = $v;
	}


	
	public function getEvent($con = null)
	{
		if ($this->aEvent === null && ($this->event_id !== null)) {
						include_once 'lib/model/om/BaseEventPeer.php';

			$this->aEvent = EventPeer::retrieveByPK($this->event_id, $con);

			
		}
		return $this->aEvent;
	}

	
	public function initCategorys()
	{
		if ($this->collCategorys === null) {
			$this->collCategorys = array();
		}
	}

	
	public function getCategorys($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCategorys === null) {
			if ($this->isNew()) {
			   $this->collCategorys = array();
			} else {

				$criteria->add(CategoryPeer::CIRCUIT_ID, $this->getId());

				CategoryPeer::addSelectColumns($criteria);
				$this->collCategorys = CategoryPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CategoryPeer::CIRCUIT_ID, $this->getId());

				CategoryPeer::addSelectColumns($criteria);
				if (!isset($this->lastCategoryCriteria) || !$this->lastCategoryCriteria->equals($criteria)) {
					$this->collCategorys = CategoryPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCategoryCriteria = $criteria;
		return $this->collCategorys;
	}

	
	public function countCategorys($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(CategoryPeer::CIRCUIT_ID, $this->getId());

		return CategoryPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addCategory(Category $l)
	{
		$this->collCategorys[] = $l;
		$l->setCircuit($this);
	}


	
	public function getCategorysJoinEvent($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCategorys === null) {
			if ($this->isNew()) {
				$this->collCategorys = array();
			} else {

				$criteria->add(CategoryPeer::CIRCUIT_ID, $this->getId());

				$this->collCategorys = CategoryPeer::doSelectJoinEvent($criteria, $con);
			}
		} else {
									
			$criteria->add(CategoryPeer::CIRCUIT_ID, $this->getId());

			if (!isset($this->lastCategoryCriteria) || !$this->lastCategoryCriteria->equals($criteria)) {
				$this->collCategorys = CategoryPeer::doSelectJoinEvent($criteria, $con);
			}
		}
		$this->lastCategoryCriteria = $criteria;

		return $this->collCategorys;
	}


	
	public function getCategorysJoinPrice($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCategorys === null) {
			if ($this->isNew()) {
				$this->collCategorys = array();
			} else {

				$criteria->add(CategoryPeer::CIRCUIT_ID, $this->getId());

				$this->collCategorys = CategoryPeer::doSelectJoinPrice($criteria, $con);
			}
		} else {
									
			$criteria->add(CategoryPeer::CIRCUIT_ID, $this->getId());

			if (!isset($this->lastCategoryCriteria) || !$this->lastCategoryCriteria->equals($criteria)) {
				$this->collCategorys = CategoryPeer::doSelectJoinPrice($criteria, $con);
			}
		}
		$this->lastCategoryCriteria = $criteria;

		return $this->collCategorys;
	}

} 