<?php


abstract class BaseCompetition extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;


	
	protected $date;


	
	protected $coach_id;

	
	protected $aUser;

	
	protected $collCompetitionCompetitors;

	
	protected $lastCompetitionCompetitorCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getDate($format = 'Y-m-d')
	{

		if ($this->date === null || $this->date === '') {
			return null;
		} elseif (!is_int($this->date)) {
						$ts = strtotime($this->date);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [date] as date/time value: " . var_export($this->date, true));
			}
		} else {
			$ts = $this->date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getCoachId()
	{

		return $this->coach_id;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = CompetitionPeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = CompetitionPeer::DESCRIPTION;
		}

	} 
	
	public function setDate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [date] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->date !== $ts) {
			$this->date = $ts;
			$this->modifiedColumns[] = CompetitionPeer::DATE;
		}

	} 
	
	public function setCoachId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->coach_id !== $v) {
			$this->coach_id = $v;
			$this->modifiedColumns[] = CompetitionPeer::COACH_ID;
		}

		if ($this->aUser !== null && $this->aUser->getId() !== $v) {
			$this->aUser = null;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->date = $rs->getDate($startcol + 2, null);

			$this->coach_id = $rs->getInt($startcol + 3);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Competition object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CompetitionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			CompetitionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CompetitionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) {
					$affectedRows += $this->aUser->save($con);
				}
				$this->setUser($this->aUser);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CompetitionPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += CompetitionPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collCompetitionCompetitors !== null) {
				foreach($this->collCompetitionCompetitors as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aUser !== null) {
				if (!$this->aUser->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUser->getValidationFailures());
				}
			}


			if (($retval = CompetitionPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collCompetitionCompetitors !== null) {
					foreach($this->collCompetitionCompetitors as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CompetitionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			case 2:
				return $this->getDate();
				break;
			case 3:
				return $this->getCoachId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CompetitionPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
			$keys[2] => $this->getDate(),
			$keys[3] => $this->getCoachId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CompetitionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
			case 2:
				$this->setDate($value);
				break;
			case 3:
				$this->setCoachId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CompetitionPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setDate($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setCoachId($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CompetitionPeer::DATABASE_NAME);

		if ($this->isColumnModified(CompetitionPeer::ID)) $criteria->add(CompetitionPeer::ID, $this->id);
		if ($this->isColumnModified(CompetitionPeer::DESCRIPTION)) $criteria->add(CompetitionPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(CompetitionPeer::DATE)) $criteria->add(CompetitionPeer::DATE, $this->date);
		if ($this->isColumnModified(CompetitionPeer::COACH_ID)) $criteria->add(CompetitionPeer::COACH_ID, $this->coach_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CompetitionPeer::DATABASE_NAME);

		$criteria->add(CompetitionPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);

		$copyObj->setDate($this->date);

		$copyObj->setCoachId($this->coach_id);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getCompetitionCompetitors() as $relObj) {
				$copyObj->addCompetitionCompetitor($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CompetitionPeer();
		}
		return self::$peer;
	}

	
	public function setUser($v)
	{


		if ($v === null) {
			$this->setCoachId(NULL);
		} else {
			$this->setCoachId($v->getId());
		}


		$this->aUser = $v;
	}


	
	public function getUser($con = null)
	{
		if ($this->aUser === null && ($this->coach_id !== null)) {
						include_once 'lib/model/om/BaseUserPeer.php';

			$this->aUser = UserPeer::retrieveByPK($this->coach_id, $con);

			
		}
		return $this->aUser;
	}

	
	public function initCompetitionCompetitors()
	{
		if ($this->collCompetitionCompetitors === null) {
			$this->collCompetitionCompetitors = array();
		}
	}

	
	public function getCompetitionCompetitors($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCompetitionCompetitorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCompetitionCompetitors === null) {
			if ($this->isNew()) {
			   $this->collCompetitionCompetitors = array();
			} else {

				$criteria->add(CompetitionCompetitorPeer::COMPETITION_ID, $this->getId());

				CompetitionCompetitorPeer::addSelectColumns($criteria);
				$this->collCompetitionCompetitors = CompetitionCompetitorPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CompetitionCompetitorPeer::COMPETITION_ID, $this->getId());

				CompetitionCompetitorPeer::addSelectColumns($criteria);
				if (!isset($this->lastCompetitionCompetitorCriteria) || !$this->lastCompetitionCompetitorCriteria->equals($criteria)) {
					$this->collCompetitionCompetitors = CompetitionCompetitorPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCompetitionCompetitorCriteria = $criteria;
		return $this->collCompetitionCompetitors;
	}

	
	public function countCompetitionCompetitors($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseCompetitionCompetitorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(CompetitionCompetitorPeer::COMPETITION_ID, $this->getId());

		return CompetitionCompetitorPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addCompetitionCompetitor(CompetitionCompetitor $l)
	{
		$this->collCompetitionCompetitors[] = $l;
		$l->setCompetition($this);
	}


	
	public function getCompetitionCompetitorsJoinUser($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCompetitionCompetitorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCompetitionCompetitors === null) {
			if ($this->isNew()) {
				$this->collCompetitionCompetitors = array();
			} else {

				$criteria->add(CompetitionCompetitorPeer::COMPETITION_ID, $this->getId());

				$this->collCompetitionCompetitors = CompetitionCompetitorPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
									
			$criteria->add(CompetitionCompetitorPeer::COMPETITION_ID, $this->getId());

			if (!isset($this->lastCompetitionCompetitorCriteria) || !$this->lastCompetitionCompetitorCriteria->equals($criteria)) {
				$this->collCompetitionCompetitors = CompetitionCompetitorPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastCompetitionCompetitorCriteria = $criteria;

		return $this->collCompetitionCompetitors;
	}

} 