<?php


abstract class BaseCompetitionCompetitor extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $competition_id;


	
	protected $competitor_id;


	
	protected $visible;

	
	protected $aCompetition;

	
	protected $aUser;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getCompetitionId()
	{

		return $this->competition_id;
	}

	
	public function getCompetitorId()
	{

		return $this->competitor_id;
	}

	
	public function getVisible()
	{

		return $this->visible;
	}

	
	public function setCompetitionId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->competition_id !== $v) {
			$this->competition_id = $v;
			$this->modifiedColumns[] = CompetitionCompetitorPeer::COMPETITION_ID;
		}

		if ($this->aCompetition !== null && $this->aCompetition->getId() !== $v) {
			$this->aCompetition = null;
		}

	} 
	
	public function setCompetitorId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->competitor_id !== $v) {
			$this->competitor_id = $v;
			$this->modifiedColumns[] = CompetitionCompetitorPeer::COMPETITOR_ID;
		}

		if ($this->aUser !== null && $this->aUser->getId() !== $v) {
			$this->aUser = null;
		}

	} 
	
	public function setVisible($v)
	{

		if ($this->visible !== $v) {
			$this->visible = $v;
			$this->modifiedColumns[] = CompetitionCompetitorPeer::VISIBLE;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->competition_id = $rs->getInt($startcol + 0);

			$this->competitor_id = $rs->getInt($startcol + 1);

			$this->visible = $rs->getBoolean($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating CompetitionCompetitor object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CompetitionCompetitorPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			CompetitionCompetitorPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CompetitionCompetitorPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aCompetition !== null) {
				if ($this->aCompetition->isModified()) {
					$affectedRows += $this->aCompetition->save($con);
				}
				$this->setCompetition($this->aCompetition);
			}

			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) {
					$affectedRows += $this->aUser->save($con);
				}
				$this->setUser($this->aUser);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CompetitionCompetitorPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += CompetitionCompetitorPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aCompetition !== null) {
				if (!$this->aCompetition->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aCompetition->getValidationFailures());
				}
			}

			if ($this->aUser !== null) {
				if (!$this->aUser->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUser->getValidationFailures());
				}
			}


			if (($retval = CompetitionCompetitorPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CompetitionCompetitorPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getCompetitionId();
				break;
			case 1:
				return $this->getCompetitorId();
				break;
			case 2:
				return $this->getVisible();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CompetitionCompetitorPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getCompetitionId(),
			$keys[1] => $this->getCompetitorId(),
			$keys[2] => $this->getVisible(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CompetitionCompetitorPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setCompetitionId($value);
				break;
			case 1:
				$this->setCompetitorId($value);
				break;
			case 2:
				$this->setVisible($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CompetitionCompetitorPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setCompetitionId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setCompetitorId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setVisible($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CompetitionCompetitorPeer::DATABASE_NAME);

		if ($this->isColumnModified(CompetitionCompetitorPeer::COMPETITION_ID)) $criteria->add(CompetitionCompetitorPeer::COMPETITION_ID, $this->competition_id);
		if ($this->isColumnModified(CompetitionCompetitorPeer::COMPETITOR_ID)) $criteria->add(CompetitionCompetitorPeer::COMPETITOR_ID, $this->competitor_id);
		if ($this->isColumnModified(CompetitionCompetitorPeer::VISIBLE)) $criteria->add(CompetitionCompetitorPeer::VISIBLE, $this->visible);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CompetitionCompetitorPeer::DATABASE_NAME);

		$criteria->add(CompetitionCompetitorPeer::COMPETITION_ID, $this->competition_id);
		$criteria->add(CompetitionCompetitorPeer::COMPETITOR_ID, $this->competitor_id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getCompetitionId();

		$pks[1] = $this->getCompetitorId();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setCompetitionId($keys[0]);

		$this->setCompetitorId($keys[1]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setVisible($this->visible);


		$copyObj->setNew(true);

		$copyObj->setCompetitionId(NULL); 
		$copyObj->setCompetitorId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CompetitionCompetitorPeer();
		}
		return self::$peer;
	}

	
	public function setCompetition($v)
	{


		if ($v === null) {
			$this->setCompetitionId(NULL);
		} else {
			$this->setCompetitionId($v->getId());
		}


		$this->aCompetition = $v;
	}


	
	public function getCompetition($con = null)
	{
		if ($this->aCompetition === null && ($this->competition_id !== null)) {
						include_once 'lib/model/om/BaseCompetitionPeer.php';

			$this->aCompetition = CompetitionPeer::retrieveByPK($this->competition_id, $con);

			
		}
		return $this->aCompetition;
	}

	
	public function setUser($v)
	{


		if ($v === null) {
			$this->setCompetitorId(NULL);
		} else {
			$this->setCompetitorId($v->getId());
		}


		$this->aUser = $v;
	}


	
	public function getUser($con = null)
	{
		if ($this->aUser === null && ($this->competitor_id !== null)) {
						include_once 'lib/model/om/BaseUserPeer.php';

			$this->aUser = UserPeer::retrieveByPK($this->competitor_id, $con);

			
		}
		return $this->aUser;
	}

} 