<?php


abstract class BaseElementFeedbackPeer {

	
	const DATABASE_NAME = 'propel';

	
	const TABLE_NAME = 'element_feedback';

	
	const CLASS_DEFAULT = 'lib.model.ElementFeedback';

	
	const NUM_COLUMNS = 7;

	
	const NUM_LAZY_LOAD_COLUMNS = 0;


	
	const ID = 'element_feedback.ID';

	
	const DESCRIPTION = 'element_feedback.DESCRIPTION';

	
	const QUANTITY = 'element_feedback.QUANTITY';

	
	const FEEDBACK_TYPE_ID = 'element_feedback.FEEDBACK_TYPE_ID';

	
	const UNIT_ID = 'element_feedback.UNIT_ID';

	
	const SESSION_ELEMENT_ID = 'element_feedback.SESSION_ELEMENT_ID';

	
	const PENDING = 'element_feedback.PENDING';

	
	private static $phpNameMap = null;


	
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('Id', 'Description', 'Quantity', 'FeedbackTypeId', 'UnitId', 'SessionElementId', 'Pending', ),
		BasePeer::TYPE_COLNAME => array (ElementFeedbackPeer::ID, ElementFeedbackPeer::DESCRIPTION, ElementFeedbackPeer::QUANTITY, ElementFeedbackPeer::FEEDBACK_TYPE_ID, ElementFeedbackPeer::UNIT_ID, ElementFeedbackPeer::SESSION_ELEMENT_ID, ElementFeedbackPeer::PENDING, ),
		BasePeer::TYPE_FIELDNAME => array ('id', 'description', 'quantity', 'feedback_type_id', 'unit_id', 'session_element_id', 'pending', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, )
	);

	
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'Description' => 1, 'Quantity' => 2, 'FeedbackTypeId' => 3, 'UnitId' => 4, 'SessionElementId' => 5, 'Pending' => 6, ),
		BasePeer::TYPE_COLNAME => array (ElementFeedbackPeer::ID => 0, ElementFeedbackPeer::DESCRIPTION => 1, ElementFeedbackPeer::QUANTITY => 2, ElementFeedbackPeer::FEEDBACK_TYPE_ID => 3, ElementFeedbackPeer::UNIT_ID => 4, ElementFeedbackPeer::SESSION_ELEMENT_ID => 5, ElementFeedbackPeer::PENDING => 6, ),
		BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'description' => 1, 'quantity' => 2, 'feedback_type_id' => 3, 'unit_id' => 4, 'session_element_id' => 5, 'pending' => 6, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, )
	);

	
	public static function getMapBuilder()
	{
		include_once 'lib/model/map/ElementFeedbackMapBuilder.php';
		return BasePeer::getMapBuilder('lib.model.map.ElementFeedbackMapBuilder');
	}
	
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = ElementFeedbackPeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	
	public static function alias($alias, $column)
	{
		return str_replace(ElementFeedbackPeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(ElementFeedbackPeer::ID);

		$criteria->addSelectColumn(ElementFeedbackPeer::DESCRIPTION);

		$criteria->addSelectColumn(ElementFeedbackPeer::QUANTITY);

		$criteria->addSelectColumn(ElementFeedbackPeer::FEEDBACK_TYPE_ID);

		$criteria->addSelectColumn(ElementFeedbackPeer::UNIT_ID);

		$criteria->addSelectColumn(ElementFeedbackPeer::SESSION_ELEMENT_ID);

		$criteria->addSelectColumn(ElementFeedbackPeer::PENDING);

	}

	const COUNT = 'COUNT(element_feedback.ID)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT element_feedback.ID)';

	
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$rs = ElementFeedbackPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}
	
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = ElementFeedbackPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return ElementFeedbackPeer::populateObjects(ElementFeedbackPeer::doSelectRS($criteria, $con));
	}
	
	public static function doSelectRS(Criteria $criteria, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if (!$criteria->getSelectColumns()) {
			$criteria = clone $criteria;
			ElementFeedbackPeer::addSelectColumns($criteria);
		}

				$criteria->setDbName(self::DATABASE_NAME);

						return BasePeer::doSelect($criteria, $con);
	}
	
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
	
				$cls = ElementFeedbackPeer::getOMClass();
		$cls = Propel::import($cls);
				while($rs->next()) {
		
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
			
		}
		return $results;
	}

	
	public static function doCountJoinFeedbackType(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(ElementFeedbackPeer::FEEDBACK_TYPE_ID, FeedbackTypePeer::ID);

		$rs = ElementFeedbackPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doCountJoinUnit(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(ElementFeedbackPeer::UNIT_ID, UnitPeer::ID);

		$rs = ElementFeedbackPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doCountJoinSessionElement(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(ElementFeedbackPeer::SESSION_ELEMENT_ID, SessionElementPeer::ID);

		$rs = ElementFeedbackPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doSelectJoinFeedbackType(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		ElementFeedbackPeer::addSelectColumns($c);
		$startcol = (ElementFeedbackPeer::NUM_COLUMNS - ElementFeedbackPeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		FeedbackTypePeer::addSelectColumns($c);

		$c->addJoin(ElementFeedbackPeer::FEEDBACK_TYPE_ID, FeedbackTypePeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = ElementFeedbackPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = FeedbackTypePeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getFeedbackType(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
										$temp_obj2->addElementFeedback($obj1); 					break;
				}
			}
			if ($newObject) {
				$obj2->initElementFeedbacks();
				$obj2->addElementFeedback($obj1); 			}
			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doSelectJoinUnit(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		ElementFeedbackPeer::addSelectColumns($c);
		$startcol = (ElementFeedbackPeer::NUM_COLUMNS - ElementFeedbackPeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		UnitPeer::addSelectColumns($c);

		$c->addJoin(ElementFeedbackPeer::UNIT_ID, UnitPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = ElementFeedbackPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = UnitPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getUnit(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
										$temp_obj2->addElementFeedback($obj1); 					break;
				}
			}
			if ($newObject) {
				$obj2->initElementFeedbacks();
				$obj2->addElementFeedback($obj1); 			}
			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doSelectJoinSessionElement(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		ElementFeedbackPeer::addSelectColumns($c);
		$startcol = (ElementFeedbackPeer::NUM_COLUMNS - ElementFeedbackPeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		SessionElementPeer::addSelectColumns($c);

		$c->addJoin(ElementFeedbackPeer::SESSION_ELEMENT_ID, SessionElementPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = ElementFeedbackPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = SessionElementPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getSessionElement(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
										$temp_obj2->addElementFeedback($obj1); 					break;
				}
			}
			if ($newObject) {
				$obj2->initElementFeedbacks();
				$obj2->addElementFeedback($obj1); 			}
			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doCountJoinAll(Criteria $criteria, $distinct = false, $con = null)
	{
		$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(ElementFeedbackPeer::FEEDBACK_TYPE_ID, FeedbackTypePeer::ID);

		$criteria->addJoin(ElementFeedbackPeer::UNIT_ID, UnitPeer::ID);

		$criteria->addJoin(ElementFeedbackPeer::SESSION_ELEMENT_ID, SessionElementPeer::ID);

		$rs = ElementFeedbackPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doSelectJoinAll(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		ElementFeedbackPeer::addSelectColumns($c);
		$startcol2 = (ElementFeedbackPeer::NUM_COLUMNS - ElementFeedbackPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		FeedbackTypePeer::addSelectColumns($c);
		$startcol3 = $startcol2 + FeedbackTypePeer::NUM_COLUMNS;

		UnitPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + UnitPeer::NUM_COLUMNS;

		SessionElementPeer::addSelectColumns($c);
		$startcol5 = $startcol4 + SessionElementPeer::NUM_COLUMNS;

		$c->addJoin(ElementFeedbackPeer::FEEDBACK_TYPE_ID, FeedbackTypePeer::ID);

		$c->addJoin(ElementFeedbackPeer::UNIT_ID, UnitPeer::ID);

		$c->addJoin(ElementFeedbackPeer::SESSION_ELEMENT_ID, SessionElementPeer::ID);

		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = ElementFeedbackPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);


					
			$omClass = FeedbackTypePeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getFeedbackType(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addElementFeedback($obj1); 					break;
				}
			}

			if ($newObject) {
				$obj2->initElementFeedbacks();
				$obj2->addElementFeedback($obj1);
			}


					
			$omClass = UnitPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj3 = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getUnit(); 				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addElementFeedback($obj1); 					break;
				}
			}

			if ($newObject) {
				$obj3->initElementFeedbacks();
				$obj3->addElementFeedback($obj1);
			}


					
			$omClass = SessionElementPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj4 = new $cls();
			$obj4->hydrate($rs, $startcol4);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj4 = $temp_obj1->getSessionElement(); 				if ($temp_obj4->getPrimaryKey() === $obj4->getPrimaryKey()) {
					$newObject = false;
					$temp_obj4->addElementFeedback($obj1); 					break;
				}
			}

			if ($newObject) {
				$obj4->initElementFeedbacks();
				$obj4->addElementFeedback($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doCountJoinAllExceptFeedbackType(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(ElementFeedbackPeer::UNIT_ID, UnitPeer::ID);

		$criteria->addJoin(ElementFeedbackPeer::SESSION_ELEMENT_ID, SessionElementPeer::ID);

		$rs = ElementFeedbackPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doCountJoinAllExceptUnit(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(ElementFeedbackPeer::FEEDBACK_TYPE_ID, FeedbackTypePeer::ID);

		$criteria->addJoin(ElementFeedbackPeer::SESSION_ELEMENT_ID, SessionElementPeer::ID);

		$rs = ElementFeedbackPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doCountJoinAllExceptSessionElement(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(ElementFeedbackPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(ElementFeedbackPeer::FEEDBACK_TYPE_ID, FeedbackTypePeer::ID);

		$criteria->addJoin(ElementFeedbackPeer::UNIT_ID, UnitPeer::ID);

		$rs = ElementFeedbackPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doSelectJoinAllExceptFeedbackType(Criteria $c, $con = null)
	{
		$c = clone $c;

								if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		ElementFeedbackPeer::addSelectColumns($c);
		$startcol2 = (ElementFeedbackPeer::NUM_COLUMNS - ElementFeedbackPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		UnitPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + UnitPeer::NUM_COLUMNS;

		SessionElementPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + SessionElementPeer::NUM_COLUMNS;

		$c->addJoin(ElementFeedbackPeer::UNIT_ID, UnitPeer::ID);

		$c->addJoin(ElementFeedbackPeer::SESSION_ELEMENT_ID, SessionElementPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = ElementFeedbackPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = UnitPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getUnit(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addElementFeedback($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initElementFeedbacks();
				$obj2->addElementFeedback($obj1);
			}

			$omClass = SessionElementPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getSessionElement(); 				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addElementFeedback($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initElementFeedbacks();
				$obj3->addElementFeedback($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doSelectJoinAllExceptUnit(Criteria $c, $con = null)
	{
		$c = clone $c;

								if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		ElementFeedbackPeer::addSelectColumns($c);
		$startcol2 = (ElementFeedbackPeer::NUM_COLUMNS - ElementFeedbackPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		FeedbackTypePeer::addSelectColumns($c);
		$startcol3 = $startcol2 + FeedbackTypePeer::NUM_COLUMNS;

		SessionElementPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + SessionElementPeer::NUM_COLUMNS;

		$c->addJoin(ElementFeedbackPeer::FEEDBACK_TYPE_ID, FeedbackTypePeer::ID);

		$c->addJoin(ElementFeedbackPeer::SESSION_ELEMENT_ID, SessionElementPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = ElementFeedbackPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = FeedbackTypePeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getFeedbackType(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addElementFeedback($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initElementFeedbacks();
				$obj2->addElementFeedback($obj1);
			}

			$omClass = SessionElementPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getSessionElement(); 				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addElementFeedback($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initElementFeedbacks();
				$obj3->addElementFeedback($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doSelectJoinAllExceptSessionElement(Criteria $c, $con = null)
	{
		$c = clone $c;

								if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		ElementFeedbackPeer::addSelectColumns($c);
		$startcol2 = (ElementFeedbackPeer::NUM_COLUMNS - ElementFeedbackPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		FeedbackTypePeer::addSelectColumns($c);
		$startcol3 = $startcol2 + FeedbackTypePeer::NUM_COLUMNS;

		UnitPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + UnitPeer::NUM_COLUMNS;

		$c->addJoin(ElementFeedbackPeer::FEEDBACK_TYPE_ID, FeedbackTypePeer::ID);

		$c->addJoin(ElementFeedbackPeer::UNIT_ID, UnitPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = ElementFeedbackPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = FeedbackTypePeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getFeedbackType(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addElementFeedback($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initElementFeedbacks();
				$obj2->addElementFeedback($obj1);
			}

			$omClass = UnitPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getUnit(); 				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addElementFeedback($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initElementFeedbacks();
				$obj3->addElementFeedback($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}

	
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	
	public static function getOMClass()
	{
		return ElementFeedbackPeer::CLASS_DEFAULT;
	}

	
	public static function doInsert($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} else {
			$criteria = $values->buildCriteria(); 		}

		$criteria->remove(ElementFeedbackPeer::ID); 

				$criteria->setDbName(self::DATABASE_NAME);

		try {
									$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}

		return $pk;
	}

	
	public static function doUpdate($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; 
			$comparison = $criteria->getComparison(ElementFeedbackPeer::ID);
			$selectCriteria->add(ElementFeedbackPeer::ID, $criteria->remove(ElementFeedbackPeer::ID), $comparison);

		} else { 			$criteria = $values->buildCriteria(); 			$selectCriteria = $values->buildPkeyCriteria(); 		}

				$criteria->setDbName(self::DATABASE_NAME);

		return BasePeer::doUpdate($selectCriteria, $criteria, $con);
	}

	
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		$affectedRows = 0; 		try {
									$con->begin();
			$affectedRows += BasePeer::doDeleteAll(ElementFeedbackPeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	 public static function doDelete($values, $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(ElementFeedbackPeer::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} elseif ($values instanceof ElementFeedback) {

			$criteria = $values->buildPkeyCriteria();
		} else {
						$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(ElementFeedbackPeer::ID, (array) $values, Criteria::IN);
		}

				$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; 
		try {
									$con->begin();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public static function doValidate(ElementFeedback $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(ElementFeedbackPeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(ElementFeedbackPeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(ElementFeedbackPeer::DATABASE_NAME, ElementFeedbackPeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = ElementFeedbackPeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	
	public static function retrieveByPK($pk, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$criteria = new Criteria(ElementFeedbackPeer::DATABASE_NAME);

		$criteria->add(ElementFeedbackPeer::ID, $pk);


		$v = ElementFeedbackPeer::doSelect($criteria, $con);

		return !empty($v) > 0 ? $v[0] : null;
	}

	
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(ElementFeedbackPeer::ID, $pks, Criteria::IN);
			$objs = ElementFeedbackPeer::doSelect($criteria, $con);
		}
		return $objs;
	}

} 
if (Propel::isInit()) {
			try {
		BaseElementFeedbackPeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log('Could not initialize Peer: ' . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
			require_once 'lib/model/map/ElementFeedbackMapBuilder.php';
	Propel::registerMapBuilder('lib.model.map.ElementFeedbackMapBuilder');
}
