<?php


abstract class BaseEvent extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;


	
	protected $celebrated_at;


	
	protected $end_inscription_at;

	
	protected $collCategorys;

	
	protected $lastCategoryCriteria = null;

	
	protected $collCircuits;

	
	protected $lastCircuitCriteria = null;

	
	protected $collInscriptions;

	
	protected $lastInscriptionCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getCelebratedAt($format = 'Y-m-d')
	{

		if ($this->celebrated_at === null || $this->celebrated_at === '') {
			return null;
		} elseif (!is_int($this->celebrated_at)) {
						$ts = strtotime($this->celebrated_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [celebrated_at] as date/time value: " . var_export($this->celebrated_at, true));
			}
		} else {
			$ts = $this->celebrated_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getEndInscriptionAt($format = 'Y-m-d')
	{

		if ($this->end_inscription_at === null || $this->end_inscription_at === '') {
			return null;
		} elseif (!is_int($this->end_inscription_at)) {
						$ts = strtotime($this->end_inscription_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [end_inscription_at] as date/time value: " . var_export($this->end_inscription_at, true));
			}
		} else {
			$ts = $this->end_inscription_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = EventPeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = EventPeer::DESCRIPTION;
		}

	} 
	
	public function setCelebratedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [celebrated_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->celebrated_at !== $ts) {
			$this->celebrated_at = $ts;
			$this->modifiedColumns[] = EventPeer::CELEBRATED_AT;
		}

	} 
	
	public function setEndInscriptionAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [end_inscription_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->end_inscription_at !== $ts) {
			$this->end_inscription_at = $ts;
			$this->modifiedColumns[] = EventPeer::END_INSCRIPTION_AT;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->celebrated_at = $rs->getDate($startcol + 2, null);

			$this->end_inscription_at = $rs->getDate($startcol + 3, null);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Event object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(EventPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			EventPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(EventPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = EventPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += EventPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collCategorys !== null) {
				foreach($this->collCategorys as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collCircuits !== null) {
				foreach($this->collCircuits as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collInscriptions !== null) {
				foreach($this->collInscriptions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = EventPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collCategorys !== null) {
					foreach($this->collCategorys as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collCircuits !== null) {
					foreach($this->collCircuits as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collInscriptions !== null) {
					foreach($this->collInscriptions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = EventPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			case 2:
				return $this->getCelebratedAt();
				break;
			case 3:
				return $this->getEndInscriptionAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = EventPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
			$keys[2] => $this->getCelebratedAt(),
			$keys[3] => $this->getEndInscriptionAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = EventPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
			case 2:
				$this->setCelebratedAt($value);
				break;
			case 3:
				$this->setEndInscriptionAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = EventPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setCelebratedAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setEndInscriptionAt($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(EventPeer::DATABASE_NAME);

		if ($this->isColumnModified(EventPeer::ID)) $criteria->add(EventPeer::ID, $this->id);
		if ($this->isColumnModified(EventPeer::DESCRIPTION)) $criteria->add(EventPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(EventPeer::CELEBRATED_AT)) $criteria->add(EventPeer::CELEBRATED_AT, $this->celebrated_at);
		if ($this->isColumnModified(EventPeer::END_INSCRIPTION_AT)) $criteria->add(EventPeer::END_INSCRIPTION_AT, $this->end_inscription_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(EventPeer::DATABASE_NAME);

		$criteria->add(EventPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);

		$copyObj->setCelebratedAt($this->celebrated_at);

		$copyObj->setEndInscriptionAt($this->end_inscription_at);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getCategorys() as $relObj) {
				$copyObj->addCategory($relObj->copy($deepCopy));
			}

			foreach($this->getCircuits() as $relObj) {
				$copyObj->addCircuit($relObj->copy($deepCopy));
			}

			foreach($this->getInscriptions() as $relObj) {
				$copyObj->addInscription($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new EventPeer();
		}
		return self::$peer;
	}

	
	public function initCategorys()
	{
		if ($this->collCategorys === null) {
			$this->collCategorys = array();
		}
	}

	
	public function getCategorys($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCategorys === null) {
			if ($this->isNew()) {
			   $this->collCategorys = array();
			} else {

				$criteria->add(CategoryPeer::EVENT_ID, $this->getId());

				CategoryPeer::addSelectColumns($criteria);
				$this->collCategorys = CategoryPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CategoryPeer::EVENT_ID, $this->getId());

				CategoryPeer::addSelectColumns($criteria);
				if (!isset($this->lastCategoryCriteria) || !$this->lastCategoryCriteria->equals($criteria)) {
					$this->collCategorys = CategoryPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCategoryCriteria = $criteria;
		return $this->collCategorys;
	}

	
	public function countCategorys($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(CategoryPeer::EVENT_ID, $this->getId());

		return CategoryPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addCategory(Category $l)
	{
		$this->collCategorys[] = $l;
		$l->setEvent($this);
	}


	
	public function getCategorysJoinCircuit($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCategorys === null) {
			if ($this->isNew()) {
				$this->collCategorys = array();
			} else {

				$criteria->add(CategoryPeer::EVENT_ID, $this->getId());

				$this->collCategorys = CategoryPeer::doSelectJoinCircuit($criteria, $con);
			}
		} else {
									
			$criteria->add(CategoryPeer::EVENT_ID, $this->getId());

			if (!isset($this->lastCategoryCriteria) || !$this->lastCategoryCriteria->equals($criteria)) {
				$this->collCategorys = CategoryPeer::doSelectJoinCircuit($criteria, $con);
			}
		}
		$this->lastCategoryCriteria = $criteria;

		return $this->collCategorys;
	}


	
	public function getCategorysJoinPrice($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCategorys === null) {
			if ($this->isNew()) {
				$this->collCategorys = array();
			} else {

				$criteria->add(CategoryPeer::EVENT_ID, $this->getId());

				$this->collCategorys = CategoryPeer::doSelectJoinPrice($criteria, $con);
			}
		} else {
									
			$criteria->add(CategoryPeer::EVENT_ID, $this->getId());

			if (!isset($this->lastCategoryCriteria) || !$this->lastCategoryCriteria->equals($criteria)) {
				$this->collCategorys = CategoryPeer::doSelectJoinPrice($criteria, $con);
			}
		}
		$this->lastCategoryCriteria = $criteria;

		return $this->collCategorys;
	}

	
	public function initCircuits()
	{
		if ($this->collCircuits === null) {
			$this->collCircuits = array();
		}
	}

	
	public function getCircuits($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCircuitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCircuits === null) {
			if ($this->isNew()) {
			   $this->collCircuits = array();
			} else {

				$criteria->add(CircuitPeer::EVENT_ID, $this->getId());

				CircuitPeer::addSelectColumns($criteria);
				$this->collCircuits = CircuitPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CircuitPeer::EVENT_ID, $this->getId());

				CircuitPeer::addSelectColumns($criteria);
				if (!isset($this->lastCircuitCriteria) || !$this->lastCircuitCriteria->equals($criteria)) {
					$this->collCircuits = CircuitPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCircuitCriteria = $criteria;
		return $this->collCircuits;
	}

	
	public function countCircuits($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseCircuitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(CircuitPeer::EVENT_ID, $this->getId());

		return CircuitPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addCircuit(Circuit $l)
	{
		$this->collCircuits[] = $l;
		$l->setEvent($this);
	}

	
	public function initInscriptions()
	{
		if ($this->collInscriptions === null) {
			$this->collInscriptions = array();
		}
	}

	
	public function getInscriptions($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseInscriptionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collInscriptions === null) {
			if ($this->isNew()) {
			   $this->collInscriptions = array();
			} else {

				$criteria->add(InscriptionPeer::EVENT_ID, $this->getId());

				InscriptionPeer::addSelectColumns($criteria);
				$this->collInscriptions = InscriptionPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(InscriptionPeer::EVENT_ID, $this->getId());

				InscriptionPeer::addSelectColumns($criteria);
				if (!isset($this->lastInscriptionCriteria) || !$this->lastInscriptionCriteria->equals($criteria)) {
					$this->collInscriptions = InscriptionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastInscriptionCriteria = $criteria;
		return $this->collInscriptions;
	}

	
	public function countInscriptions($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseInscriptionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(InscriptionPeer::EVENT_ID, $this->getId());

		return InscriptionPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addInscription(Inscription $l)
	{
		$this->collInscriptions[] = $l;
		$l->setEvent($this);
	}

} 